Index: trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/src/G4QEnvironment.cc
===================================================================
--- trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/src/G4QEnvironment.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/src/G4QEnvironment.cc	(revision 1055)
@@ -1712,5 +1824,5 @@
         sumstat           += Qst;
 #ifdef pdebug
-	       G4cout<<"G4QEnv::HadrQE:#"<<iq<<", Qst="<<Qst<<", Q="<<Q4M<<Q4M.m()<<QQC<<", Env="
+        G4cout<<"G4QEnv::HadrQE:#"<<iq<<", Qst="<<Qst<<", Q="<<Q4M<<Q4M.m()<<QQC<<", Env="
               <<theEnvironment<<G4endl;
 #endif
@@ -1721,11 +1833,11 @@
         }
         if(Qst>0)                  eCount++;     // Incr. counter of existing Quasmons 
-	     } // End of summation LOOP over Quasmons
+      } // End of summation LOOP over Quasmons
       G4int      totS  =totQC.GetStrangeness();  // Total Strangeness of the Total System
       G4int      totBN =totQC.GetBaryonNumber(); // Total Baryon Number of the Total System
       G4int      totPDG=0;                       // Total PDG Code for the Current compound
       G4double   totM  =0.;                      // min(GroundSt)Mass of theResidualSystem
-      if(totBN<2)  
-	     {
+      if(totBN < 2)                              // Solution for the light nucleus  
+      {
         totPDG=totQC.GetSPDGCode();              // Min totPDGCode for theCurrentCompound
         if(totPDG) totM=G4QPDGCode(totPDG).GetMass(); // min Mass of the Residual System
@@ -1733,13 +1845,13 @@
       }
       else
-	     {
+      {
         G4QNucleus totN(totQC,tot4M);            // Excited nucleus for theResidualSystem
         totM=totN.GetMZNS();                     // min(GroundSt)Mass of theResidualSystem
         totPDG=totN.GetPDG();                    // Total PDG Code for the Current compound
-	     }
+      }
 #ifdef fdebug
-	     G4cout<<"G4QEnv::HadrQE:totC="<<totC<<"<totCM="<<totCM<<",ss="<<sumstat<<G4endl;
-#endif
-      if(totC>=totCM||cbR>cbRM)
+      G4cout<<"G4QEnv::HadrQE:totC="<<totC<<"<totCM="<<totCM<<",ss="<<sumstat<<G4endl;
+#endif
+      if ( totC >= totCM || cbR > cbRM)
       {
         CleanUp();
@@ -1747,14 +1859,14 @@
         EvaporateResidual(evH);             // Try to evaporate residual (del. equiv.)
         return theQHadrons;
-	     }
+      }
       // === Now we should be prepared for evaporation ===
       G4int      totChg=totQC.GetCharge();    // Total Electric Charge of the Total System
 #ifdef pdebug
       if(totPDG==90999999||totPDG==90999000||totPDG==90000999||totPDG==89999001)
-		    G4cout<<"***G4QEnv::HadrQEnv: Meson (1) PDG="<<totPDG<<", M="<<tot4M.m()<<G4endl;
+      G4cout<<"***G4QEnv::HadrQEnv: Meson (1) PDG="<<totPDG<<", M="<<tot4M.m()<<G4endl;
       G4int           nOH=theQHadrons.size(); // A#of output hadrons
       G4LorentzVector s4M=tot4M;              // Total 4-momentum (@@ only for checking)
       if(nOH) for(G4int ih=0; ih<nOH; ih++) s4M+=theQHadrons[ih]->Get4Momentum();     
-	     G4cout<<"G4QEnv::HadrQE:tBN="<<totBN<<",s="<<sumstat<<",fC="<<fCount<<",eC="<<eCount
+      G4cout<<"G4QEnv::HadrQE:tBN="<<totBN<<",s="<<sumstat<<",fC="<<fCount<<",eC="<<eCount
             <<",En="<<theEnvironment<<",nH="<<nOH<<",tLV="<<s4M<<totQC<<nCount<<G4endl;
 #endif
@@ -1767,26 +1879,26 @@
         else if(totPDG==2224) totM=mProt+mPi;
         else if(totPDG==10)
-		      {
+        {
           G4QChipolino totChip(totQC);        // define the residual as a Chipolino
           totM  =totChip.GetQPDG1().GetMass()+totChip.GetQPDG2().GetMass();
-		      }
+        }
         else
-		      {
+        {
           G4cerr<<"***G4QEnv::HadrQE:totPDG="<<totPDG<<", totQC="<<totQC<<G4endl;
           throw G4QException("G4QEnvironment::HadronizeQEnvir: ImpossibleHadron in CHIPS");
-		      }
-	     }
+        }
+      }
       G4double totMass = tot4M.m();           // Total effective Mass
-      G4bool   Premium = eCount&&premC&&envM; // Premium condition
-      G4int    count3  =0;
-      if(sumstat&&(fCount||Premium)&&!force&&count3<c3Max)//=>"Still try to decay Quasmons"
-	     {
+      G4bool   Premium = eCount && premC && envM; // Premium condition
+      G4int    count3  = 0;
+      if(sumstat && (fCount||Premium) && !force && count3<c3Max)//=>"Force Quasmons decay"
+      {
         if(!fCount) premC--;                  // Reduce premium efforts counter
-	       if(nQuasmons) for (G4int jq=0; jq<nQuasmons; jq++)//FragmentationLOOP over Quasmons
-	       {
-	         G4Quasmon* pQ     = theQuasmons[jq];// Pointer to the CurrentQuasmon <--<--<--+
+        if(nQuasmons) for (G4int jq=0; jq<nQuasmons; jq++)//FragmentationLOOP over Quasmons
+        {
+          G4Quasmon* pQ     = theQuasmons[jq];// Pointer to the CurrentQuasmon <--<--<--+
           G4int      status = pQ->GetStatus();// Old status of the Quasmon              ^
 #ifdef pdebug
-	         G4cout<<"G4QE::HQE:Status of Q#"<<jq<<" (before Fragment)="<<status<<G4endl;//^
+          G4cout<<"G4QE::HQE:Status of Q#"<<jq<<" (before Fragment)="<<status<<G4endl;//^
 #endif
           if(status)                          // Skip dead Quasmons                     ^
@@ -1794,7 +1906,7 @@
             G4int nQuas=eCount;
             if(nQuas==1&&first) nQuas=-nQuas;
- 	          G4QHadronVector* output=pQ->Fragment(theEnvironment,nQuas);//<DESTRUCT<--<--^-+
-#ifdef pdebug
-	           G4cout<<"G4QE::HQE:Q#"<<jq<<",*afterFragm* Env="<<theEnvironment<<G4endl;// ^ ^
+            G4QHadronVector* output=pQ->Fragment(theEnvironment,nQuas);//<DESTRUCT<--<--^-+
+#ifdef pdebug
+            G4cout<<"G4QE::HQE:Q#"<<jq<<",*afterFragm* Env="<<theEnvironment<<G4endl;// ^ ^
 #endif
             envM =theEnvironment.GetMass();   // new mass of Nuclear Environment        ^ ^
@@ -1803,15 +1915,15 @@
             G4int nHadrons = output->size();  //                                        ^ ^
 #ifdef rdebug
-	           G4cout<<"G4QE::HQE:**AfterFragmAttempt**#"<<jq<<",stat="<<status<<", Q4M="//^ ^
+            G4cout<<"G4QE::HQE:**AfterFragmAttempt**#"<<jq<<",stat="<<status<<", Q4M="//^ ^
                   <<pQ->Get4Momentum()<<", Env="<<theEnvironment<<",nH="<<nHadrons //   ^ ^
                   <<",c3="<<count3<<" < "<<c3Max<<",eC="<<eCount<<G4endl;          //   ^ ^
             G4int tC=totInC-theEnvironment.GetZ(); // Subtract theResidualEnvironCharge ^ ^
             G4LorentzVector t4M=totIn4M;      // Compare with the total                 ^ ^
-			         G4LorentzVector theEnv4m=theEnvironment.Get4Momentum(); // Environment 4Mom ^ ^
-			         t4M-=theEnv4m;                    // Subtract the Environment 4-momentum    ^ ^
+            G4LorentzVector theEnv4m=theEnvironment.Get4Momentum(); // Environment 4Mom ^ ^
+            t4M-=theEnv4m;                    // Subtract the Environment 4-momentum    ^ ^
             G4cout<<"G4QEnv::HadrQE:SUM-4Mom e4M="<<theEnv4m<<theEnvironment<<G4endl;// ^ ^
-	           for (G4int js=0; js<nQuasmons; js++)// Subtract 4mom's of Quasmons (compare)^ ^
+            for (G4int js=0; js<nQuasmons; js++)// Subtract 4mom's of Quasmons (compare)^ ^
             {                                 //                                        ^ ^
-	             G4Quasmon*      prQ = theQuasmons[js];//                                  ^ ^
+              G4Quasmon*      prQ = theQuasmons[js];//                                  ^ ^
               if(prQ->GetStatus())            // Subtract only if Quasmon is alive      ^ ^
               {                               //                                        ^ ^
@@ -1821,10 +1933,10 @@
                 t4M          -= Q4M;          //                                        ^ ^
                 tC           -= prQ->GetQC().GetCharge(); //                            ^ ^
-			           }                               //                                        ^ ^
+              }                               //                                        ^ ^
               else G4cout<<"G4QE::HQE:SUM-4M,st("<<js<<")="<<prQ->GetStatus()<<G4endl;//^ ^
-	           } // End of Quasmons4Momentum subtractions                                  ^ ^
+            } // End of Quasmons4Momentum subtractions                                  ^ ^
             G4int nsbHadr=theQHadrons.size(); // Update the value of OUTPUT entries     ^ ^
             if(nsbHadr) for(G4int jpo=0; jpo<nsbHadr; jpo++)// LOOP over output hadrons ^ ^
-			         {                                 //                                        ^ ^
+            {                                 //                                        ^ ^
               G4int hsNF  = theQHadrons[jpo]->GetNFragments();// A#of out fragments     ^ ^
               if(!hsNF)                       // Subtract only final hadrons            ^ ^
@@ -1835,13 +1947,13 @@
                 t4M          -= hs4Mom;       //                                        ^ ^
                 tC           -= theQHadrons[jpo]->GetCharge(); //                       ^ ^
-	  		         }                               // End of the "FinalHadron" IF            ^ ^
+              }                               // End of the "FinalHadron" IF            ^ ^
             }                                 // End of the LOOP over output hadrons    ^ ^
             if(nHadrons) for(G4int kpo=0; kpo<nHadrons; kpo++)//LOOP over out QHadrons  ^ ^
             {                                 //                                        ^ ^
-	  		         //G4QHadron* insH =output->operator[](kpo);// Pointer to theOutputQHadron ^ ^
-	  		         G4QHadron* insH = (*output)[kpo];// Pointer to the Output QHadron         ^ ^
+              //G4QHadron* insH =output->operator[](kpo);// Pointer to theOutputQHadron ^ ^
+              G4QHadron* insH = (*output)[kpo];// Pointer to the Output QHadron         ^ ^
               G4int qhsNF  = insH->GetNFragments(); // A#of secondary fragments         ^ ^
               if(!qhsNF)                      // Subtract only final hadrons            ^ ^
-			           {                               //                                        ^ ^
+              {                               //                                        ^ ^
                 G4LorentzVector qhs4Mom = insH->Get4Momentum();// 4M of theOutputQHadron^ ^
                 G4int hPDG = insH->GetPDGCode(); //  PDG Code of the Q-output Hadron    ^ ^
@@ -1849,5 +1961,5 @@
                 t4M          -= qhs4Mom;      //                                        ^ ^
                 tC           -= insH->GetCharge(); //                                   ^ ^
-			           }                               //                                        ^ ^
+              }                               //                                        ^ ^
             }                                 // End of the LOOP over output QHadrons   ^ ^
             G4cout<<"G4QEnv::HadrQE:|||||4-MomCHECK||||d4M="<<t4M<<",dC="<<tC<<G4endl;//^ ^
@@ -1858,8 +1970,8 @@
               if(nHadrons>0)                  // Transfer QHadrons from Quasm to Output ^ ^
               {                               //                                        ^ ^
-    	           for (G4int ih=0; ih<nHadrons; ih++) // LOOP over Q-output QHadrons      ^ ^
+                for (G4int ih=0; ih<nHadrons; ih++) // LOOP over Q-output QHadrons      ^ ^
                 {                             //                                        ^ ^
-				              //G4QHadron* inpH = output->operator[](ih); //                        ^ ^
-				              G4QHadron* inpH = (*output)[ih]; //                                   ^ ^
+                  //G4QHadron* inpH = output->operator[](ih); //                        ^ ^
+                  G4QHadron* inpH = (*output)[ih]; //                                   ^ ^
                   G4int hC=inpH->GetCharge(); // Charge of the Hadron                   ^ ^
                   G4int hF=inpH->GetNFragments();// Number of fragments                 ^ ^
@@ -1877,8 +1989,8 @@
                     hCB=theEnvironment.CoulombBarrier(hC,hB); //                        ^ ^
                     hKE=hLV.e()-hLV.m();      //                                        ^ ^
-				              }                           //                                        ^ ^
-                  if(can&&hKE<hCB)            // => "Suck Hadron in Quasm or Env" case  ^ ^
-				              {                           //                                        ^ ^
-                    if(status)                // => "Suck in the existing Quasmon" case ^ ^
+                  }                           //                                        ^ ^
+                  if(can&&hKE<hCB)            // => "Suck Hadron into Quas or Env" case ^ ^
+                  {                           //                                        ^ ^
+                    if(status)                // => "Suck into existing Quasmon" case   ^ ^
                     {                         //                                        ^ ^
                       G4QContent tQC=inpH->GetQC()+pQ->GetQC();  //                     ^ ^
@@ -1886,8 +1998,8 @@
                       pQ->InitQuasmon(tQC,tLV); // Reinitialize the current Quasmon     ^ ^
 #ifdef pdebug
-	                     G4cout<<"G4QE::HQE:Medium, H#"<<ih<<", QPDG="<<inpH->GetQPDG() // ^ ^
+                      G4cout<<"G4QE::HQE:Medium, H#"<<ih<<", QPDG="<<inpH->GetQPDG() // ^ ^
                             <<",4M="<<inpH->Get4Momentum()<<" is suckedInQ"<<G4endl; // ^ ^
 #endif
-				                }                         //                                        ^ ^
+                    }                         //                                        ^ ^
                     else                      // => "Suck in the existing Quasmon" case ^ ^
                     {                         //                                        ^ ^
@@ -1896,9 +2008,9 @@
                       theEnvironment=G4QNucleus(tQC,tLV); // Reinit currentEnvironment  ^ ^
 #ifdef pdebug
-	                     G4cout<<"G4QE::HQE:Med,H#"<<ih<<",PDG="<<inpH->GetQPDG()<<",4M="//^ ^
+                      G4cout<<"G4QE::HQE:Med,H#"<<ih<<",PDG="<<inpH->GetQPDG()<<",4M="//^ ^
                             <<inpH->Get4Momentum()<<" is suckedInEnvironment"<<G4endl;//^ ^
 #endif
-				                }                         // End of the STATUS IF                   ^ ^
-				              }                           // End of the E/Q suck Hdron IF           ^ ^
+                    }                         // End of the STATUS IF                   ^ ^
+                  }                           // End of the E/Q suck Hdron IF           ^ ^
                   else if(!hF)                // => "Hadron can go out" case            ^ ^
                   {                           //                                        ^ ^
@@ -1910,5 +2022,5 @@
                     G4double phZ=ph4M.z();    // p_x of the hadron                      ^ ^
                     G4double phCost=phZ/sqrt(phX*phX+phY*phY+phZ*phZ);// Hadr cos(theta)^ ^
-	                   G4cout<<"G4QEnv::HadrQE:Medium, H#"<<ih<<",QPDG="<<curH->GetQPDG()//^ ^
+                    G4cout<<"G4QEnv::HadrQE:Medium, H#"<<ih<<",QPDG="<<curH->GetQPDG()//^ ^
                           <<", 4M="<<ph4M<<", ct="<<phCost<<G4endl; //                  ^ ^
 #endif
@@ -1916,19 +2028,19 @@
                     totQC-=curH->GetQC();     //                                        ^ ^
                     tot4M-=curH->Get4Momentum(); //                                     ^ ^
-				              }                           //                                        ^ ^
-				            }                             // ==> End of the LOOP over outQHadrons   ^ ^
+                  }                           //                                        ^ ^
+                }                             // ==> End of the LOOP over outQHadrons   ^ ^
                 pQ->ClearOutput();            // Hadrons are filled, Clear Frag-out <-<-^ ^
                 count3=0;                     // Reset counter of empty hadronizations    ^
                 //c3Max=1;                    // Reduce repetition Max to accelerate      ^
                 first=false;                  // First hadronization is for sure is over  ^
-	             }                               //                                          ^
+              }                               //                                          ^
               else count3++;                  // Increment counter of empty hadronizations^
-			         }                                 //                                          ^
+            }                                 //                                          ^
             else if(status<0||status==2)      // => "PANIC or NOTHING was done" case      ^
             {                                 //                                          ^
 #ifdef pdebug
-	             G4cout<<"G4QE::HQE:***PANIC***,status="<<status<<",nC="<<nCount<<G4endl; // ^
-#endif
-														nCount++;                       //                                          ^
+              G4cout<<"G4QE::HQE:***PANIC***,status="<<status<<",nC="<<nCount<<G4endl; // ^
+#endif
+              nCount++;                       //                                          ^
               if(eCount==1 && status<0 && CheckGroundState(pQ,true))// Correct & Finish   ^
               {                               //                                          ^
@@ -1943,12 +2055,52 @@
               else if(status<0&&nHadrons)     // This is just a confusion in the status...^
               {                               //                                          ^
-		              G4cerr<<"***G4QEnv::HadrQE: nH="<<nHadrons<<"< status="<<status<<G4endl;//^
+                G4cerr<<"***G4QEnv::HadrQE: nH="<<nHadrons<<"< status="<<status<<G4endl;//^
                 for_each(output->begin(), output->end(), DeleteQHadron()); // -->-->-->---^
                 output->clear();              //                                          ^
                 delete output;                // >========================================^
                 throw G4QException("G4QEnvironment::HadronizeQEnvironment:DoNothingEr");//^
-			           }                               //                                          ^
+              }                               //                                          ^
+              else if(status==2 && eCount==1 && cAN<mcAN && envM>500.)// Add N from E to Q^
+              {                               //                                          ^
+#ifdef pdebug
+		    G4cout<<"G4QE::HQE:E="<<theEnvironment<<",M="<<envM<<",c="<<cAN<<G4endl;//^
+#endif
+                cAN++;                        // Increment the counter of absorptions     ^
+                G4int envPDG = theEnvironment.GetPDG(); // PDGCode of the NuclQEnvironment^
+                G4LorentzVector env4M=theEnvironment.Get4Momentum(); // 4mom of the NucEnv^
+                G4int envN=theEnvironment.GetN();                    // N of Env          ^
+                G4int envZ=theEnvironment.GetZ();                    // Z of Env          ^
+                G4int resPDG=envPDG-1;        // Residual for the neutron (prototype)     ^
+                G4QContent nucQC=neutQC;      // Nucleon Quark Content                    ^
+                if ( envN && (envN+envZ)*G4UniformRand() > envZ ) // Change to a proton   ^
+                {                             //                                          ^
+                  resPDG=envPDG-1000;         // new PDG for the Environment              ^
+                  nucQC=protQC;               // proton QContent                          ^
+                }                             //                                          ^
+#ifdef pdebug
+		    G4cout<<"G4QE::HQE:P,eZ="<<envZ<<",eN="<<envN<<",rPDG="<<resPDG<<G4endl;//^
+#endif
+                G4QNucleus resNuc(resPDG);    // Create the residual nucleus (future Env) ^
+                G4double resM=resNuc.GetGSMass();       // Mass of the residual nucleus   ^
+                G4double eM=theEnvironment.GetGSMass(); // Mass of the current environment^
+                G4double nucM=eM-resM;                  // Effective mass of theNucleon   ^
+                G4LorentzVector res4M(0.,0.,0.,resM);   // Prototype of newEnv4M (at rest)^
+                G4LorentzVector nuc4M(0.,0.,0.,nucM);   // Prototype of newEnv4M (at rest)^
+                if(std::fabs(env4M.e()-eM) > 0.001)     // the Environment is not at rest ^
+                {                                       //                                ^
+                  res4M=(resM/eM)*env4M;                // Proportional 4M for residEnv   ^
+                  nuc4M=(nucM/eM)*env4M;                // Proportional 4M for effNucleon ^
+                }                                       //                                ^
+                theEnvironment=G4QNucleus(res4M,resPDG);// Update the Environment         ^
+                theQuasmons[0]->IncreaseBy(nucQC,nuc4M);// Update the Only Quasmon        ^
+#ifdef pdebug
+		    G4cout<<"G4QE::HQE:P,Q="<<nucQC<<nuc4M<<",env="<<theEnvironment<<G4endl;//^
+#endif
+              }                                         //                                ^
               else if(status==2&&nCount>nCnMax)// Treat PANIC for stat=2 (NothingWasDone) ^
               {                               //                                          ^
+#ifdef pdebug
+		    G4cout<<"G4QE::HQE:PANIC,nC="<<nCount<<">"<<nCnMax<<G4endl; //            ^
+#endif
                 G4QContent qQC=pQ->GetQC();   // QuarkContent of the Quasmon              ^
                 G4int      pqC=qQC.GetCharge(); // Charge (nP) of the Current Quasmon     ^
@@ -1959,15 +2111,15 @@
                 G4double fqMass=G4QPDGCode(22).GetNuclMass(pqC,pqB-pqC-pqS,pqS);//CQ FreeM^
 #ifdef edebug
-    		          G4cout<<"G4QEnv::HQE:M="<<cqMass<<">fM="<<fqMass<<",S="<<pqS<<",C="<<pqC//^
+                G4cout<<"G4QEnv::HQE:M="<<cqMass<<">fM="<<fqMass<<",S="<<pqS<<",C="<<pqC//^
                       <<",ePDG="<<theEnvironment.GetPDG()<<",qQC="<<qQC<<",eC="<<eCount //^
                       <<G4endl;                                                     //    ^
 #endif
                 if(pqB>0&&pqS<0&&cqMass>fqMass)// "AntiStrangeNucleus-Chipolino" case     ^
-				            {                             //                                          ^
+                {                             //                                          ^
                   G4QHadron* nuclQ = new G4QHadron(qQC,cq4M);// Hadron for AntiStrangeNuc.^
                   theEnvironment.DecayAntiStrange(nuclQ,&theQHadrons);// AntiStrange(D.E.)^
                   pQ->KillQuasmon();          // If BackFusion succeeded, kill theQuasmon ^
 #ifdef edebug
-     		           G4cout<<"G4QEnv::HQE:Status after kill (#"<<jq<<")="<<pQ->GetStatus()// ^
+                  G4cout<<"G4QEnv::HQE:Status after kill (#"<<jq<<")="<<pQ->GetStatus()// ^
                         <<", nH="<<theQHadrons.size()<<G4endl;                         // ^
 #endif
@@ -1977,9 +2129,9 @@
                 }                             //                                          ^
                 else if(theEnvironment.GetPDG()!=NUCPDG) // ==> "NuclearEnvironment" case ^
-				            {                             //                                          ^
+                {                             //                                          ^
                   if(eCount>1)                //                                          ^
-																		{                           //                                          ^
+                  {                           //                                          ^
 #ifdef fdebug
-		                  G4cout<<"G4QE::HQE:TOTEVAP tPDG="<<totPDG<<",t4M="<<tot4M<<G4endl; // ^
+                    G4cout<<"G4QE::HQE:TOTEVAP tPDG="<<totPDG<<",t4M="<<tot4M<<G4endl; // ^
 #endif
                     G4QHadron* evH = new G4QHadron(totQC,tot4M); // Create Hadron-ResidNuc^
@@ -1998,5 +2150,5 @@
                   G4double   curM=curE.GetGSMass();// min mass of the Total System        ^
 #ifdef edebug
-    		            G4cout<<"G4QEnv::HQE:Q#"<<jq<<",tM="<<tM<<">gsM="<<curM<<curE<<G4endl;//^
+                  G4cout<<"G4QEnv::HQE:Q#"<<jq<<",tM="<<tM<<">gsM="<<curM<<curE<<G4endl;//^
 #endif
                   if(tM<curM)                 //                                          ^
@@ -2005,18 +2157,18 @@
                     G4double qMass=G4QPDGCode(qPDG).GetMass(); // GroundStM of theQuasmon ^
 #ifdef edebug
-    		              G4cout<<"G4QE::HQE:nQ="<<nQuasmons<<",eC="<<eCount<<",qPDG="<<qPDG // ^
+                    G4cout<<"G4QE::HQE:nQ="<<nQuasmons<<",eC="<<eCount<<",qPDG="<<qPDG // ^
                           <<",qM="<<qMass<<",eM="<<envM<<",tM="<<tM<<",Q+E="<<qMass+envM//^
                           <<G4endl;           //                                          ^
 #endif
                     if(eCount==1&&qPDG&&qMass&&tM>qMass+envM)//==> Q+E decay for one Quasm^
-					               //if(nQuasmons==1 && qPDG && qMass && tM>qMass+envM) // ==> Q+E decay ^
+                    //if(nQuasmons==1 && qPDG && qMass && tM>qMass+envM) // ==> Q+E decay ^
                     {                         //                                          ^
                       G4int envPDG = theEnvironment.GetPDG(); // PDGCode of the NuclQEnv. ^
 #ifdef edebug
-		                    G4cout<<"G4QEnv::HadrQEnv: Q+E decay, nQ=1, qPDG=="<<qPDG<<G4endl;//^
+                      G4cout<<"G4QEnv::HadrQEnv: Q+E decay, nQ=1, qPDG=="<<qPDG<<G4endl;//^
 #endif
                       // => "Quasmon-Chipolino or Environment-Dibaryon" case              ^
                       if(qPDG==10 || qPDG==92000000 || qPDG==90002000 || qPDG==90000002)//^
-																						{                          //                                       ^
+                      {                          //                                       ^
                         G4QPDGCode h1QPDG=nQPDG; // QPDG of the first hadron              ^
                         G4double   h1M   =mNeut; // Mass of the first hadron              ^
@@ -2024,5 +2176,5 @@
                         G4double   h2M   =mNeut; // Mass of the second hadron             ^
                         if(qPDG==10)             // CHIPOLINO decay case                  ^
-						                  {                     //                                          ^
+                        {                     //                                          ^
                           G4QChipolino QChip(qQC);// define the Quasmon as a Chipolino    ^
                           h1QPDG=QChip.GetQPDG1();// QPDG of the first hadron             ^
@@ -2030,6 +2182,6 @@
                           h2QPDG=QChip.GetQPDG2();// QPDG of the second hadron            ^
                           h2M   =h2QPDG.GetMass();// Mass of the second hadron            ^
-			                     }                     //                                          ^
-			                     else if(qPDG==90002000) // DiProton decay case                    ^
+                        }                     //                                          ^
+                        else if(qPDG==90002000) // DiProton decay case                    ^
                         {                     //                                          ^
                           h1QPDG=pQPDG;       // QPDG of the first hadron                 ^
@@ -2037,6 +2189,6 @@
                           h2QPDG=h1QPDG;      // QPDG of the second hadron                ^
                           h2M   =mProt;       // Mass of the second hadron                ^
-			                     }                     //                                          ^
-			                     else if(qPDG==92000000) // Two lambdas case                       ^
+                        }                     //                                          ^
+                        else if(qPDG==92000000) // Two lambdas case                       ^
                         {                     //                                          ^
                           h1QPDG=lQPDG;       // QPDG of the first hadron                 ^
@@ -2046,5 +2198,5 @@
                           G4double ddMass=totMass-envM; // Free CM energy                 ^
                           if(ddMass>mSigZ+mSigZ) // Sigma0+Sigma0 is possible             ^
-						                    {                   // @@ Only two particles PS is used         ^
+                          {                   // @@ Only two particles PS is used         ^
                             G4double dd2=ddMass*ddMass; // Squared free energy            ^
                             G4double sma=mLamb+mLamb; // Lambda+Lambda sum                ^
@@ -2054,6 +2206,6 @@
                             G4double smi=mSigZ-mLamb; // Sigma0-Lambda difference         ^
                             G4double pr2=pr1;         // Prototype of +L+S0 PS            ^
-																												if(ddMass>sma&&ddMass>smi) //                                 ^
-																													 pr2+=sqrt((dd2-sma*sma)*(dd2-smi*smi)); //                  ^
+                            if(ddMass>sma&&ddMass>smi) //                                 ^
+                              pr2+=sqrt((dd2-sma*sma)*(dd2-smi*smi)); //                  ^
                             sma=mSigZ+mSigZ;          // Sigma0+Sigma0 sum                ^
                             G4double pr3=pr2;         // Prototype of +Sigma0+Sigma0 PS   ^
@@ -2074,5 +2226,5 @@
                           }                   //                                          ^
                           else if(ddMass>mSigZ+mLamb) // Lambda+Sigma0 is possible        ^
-						                    {                   // @@ Only two particles PS is used         ^
+                          {                   // @@ Only two particles PS is used         ^
                             G4double dd2=ddMass*ddMass; // Squared free energy            ^
                             G4double sma=mLamb+mLamb; // Lambda+Lambda sum                ^
@@ -2083,5 +2235,5 @@
                             G4double pr2=pr1;         //+L+S0 PS                          ^
                             if(ddMass>sma && ddMass>smi) //                               ^
-																														pr2+=sqrt((dd2-sma*sma)*(dd2-smi*smi)); //                  ^
+                              pr2+=sqrt((dd2-sma*sma)*(dd2-smi*smi)); //                  ^
                             if(pr2*G4UniformRand()>pr1) // --> "ENnv+Sigma0+Lambda" case  ^
                             {                 //                                          ^
@@ -2090,5 +2242,5 @@
                             }                 //                                          ^
                           }                   //                                          ^
-			                     }                     //                                          ^
+                        }                     //                                          ^
                         if(h1M+h2M+envM<totMass) // => "Three parts decay" case           ^
                         {                     //                                          ^
